'''
Helpful mathematical functions and constants.

@author: Donovan Parks
'''

import math

def mean(x):
  if len(x) == 0:
    return float('nan')
    
  sum = 0.0
  for i in xrange(0, len(x)):
    sum += x[i]
  return sum / len(x)
  
def stdDev(x):
  if len(x) == 0:
    return float('nan')
    
  m = mean(x)
  sumsq = 0.0
  for i in xrange(0, len(x)):
    sumsq += (x[i] - m)*(x[i] - m)
  return math.sqrt(sumsq / len(x))